#ifndef CDPANEL_H
#define CDPANEL_H

Class *CDPANEL_GetClass(void);

#pragma libcall CDPanelBase CDPANEL_GetClass 1e 00

#define CDPANEL_Dummy		(TAG_USER+0x04010000)

#define CDPANEL_TotalTime	(CDPANEL_Dummy+1)
/*	(ULONG) The total playing time of this CD in seconds */

#define CDPANEL_Time		(CDPANEL_Dummy+2)
/*	(ULONG) The current playing time offset into the CD */

#define CDPANEL_Tracks		(CDPANEL_Dummy+3)
/*	(ULONG) Number of tracks on the CD */

#define CDPANEL_TrackTimes	(CDPANEL_Dummy+4)
/*	(ULONG *) ~0 terminated array of track lenghts in seconds */

#define CDPANEL_Status		(CDPANEL_Dummy+5)
/*	(ULONG) Current CD player status, see below for defines */

#define CDP_EMPTY	0	/* no CD in */
#define CDP_PLAYING	1	/* playing */
#define CDP_PAUSED	2	/* paused */
#define CDP_STOPPED 3	/* CD in, not playing */
#define CDP_SEEKING	4	/* seeking to a track */
#define	CDP_EJECTED	5	/* tray out */

#define CDPANEL_Artist		(CDPANEL_Dummy+6)
/*	(STRPTR) Artist name */

#define CDPANEL_Title		(CDPANEL_Dummy+7)
/*	(STRPTR) CD title */

#define CDPANEL_TrackTitles	(CDPANEL_Dummy+8)
/*	(STRPTR *) The titles in an array, at least CDPANEL_Tracks entries */

#define CDPANEL_BgPen		(CDPANEL_Dummy+9)
/*	(WORD) Pen to use for background */

#define CDPANEL_FgPen		(CDPANEL_Dummy+10)
/*	(WORD) Pen to use for foreground (text) */

#define CDPANEL_Track		(CDPANEL_Dummy+11)
/*	(ULONG) Number of the current playing track */

#define CDPANEL_TrackTime	(CDPANEL_Dummy+12)
/*	(ULONG) Current time for this track */

#define CDPANEL_NoBorder	(CDPANEL_Dummy+13)
/*	(ULONG) Don't do a bevel border around the gadget */

#endif
